LeetCode 292. Nim Game

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.
Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.
For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

题目分析:

其实这道题比较trick,思路就是,由于每个人每次拿1-3个stone,并且你是第一个开始拿的,因此只要最后剩下4个stone,你就一定会输。所以当原来的stone数是4的倍数,那么只要每次都保证每轮拿完stone后的数量是4的倍数就行,这样在最后一轮一定会剩下4个stone,这个时候先拿的人就输了。同理,如果每人拿1-4个stone,那么只要总数是5的倍数,先拿的人就一定会输。

代码:
class Solution {
    public boolean canWinNim(int n) {
        return n % 4 != 0 ;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值